searchNodes=[{"doc":"Raspberry Pi Model Zero This is the base Nerves System configuration for the Raspberry Pi Zero and Raspberry Pi Zero W. If you are not interested in Gadget Mode then check out nerves_system_rpi . That system configures the USB port in host mode by default and is probably more appropriate for your setup. &lt;sup&gt;[Image credit](#fritzing)&lt;/sup&gt; Feature Description CPU 1 GHz ARM1176JZF-S Memory 512 MB Storage MicroSD Linux kernel 5.4 w/ Raspberry Pi patches IEx terminal UART ttyAMA0 Can be changed to HDMI GPIO, I2C, SPI Yes - Elixir Circuits ADC No PWM Yes, but no Elixir support UART 1 available - ttyAMA0 Camera Yes - via rpi-userland Ethernet No WiFi Supported on the Pi Zero W Bluetooth Not supported yet Audio HDMI/Stereo out","ref":"readme.html","title":"Raspberry Pi Model Zero","type":"extras"},{"doc":"The most common way of using this Nerves System is create a project with mix nerves.new and to export MIX_TARGET=rpi0 . See the Getting started guide for more information. If you need custom modifications to this system for your device, clone this repository and update as described in Making custom systems","ref":"readme.html#using","title":"Raspberry Pi Model Zero - Using","type":"extras"},{"doc":"One of the goals of this system is to make it possible to do most development via one USB cable. That cable, when plugged into the USB OTG port, powers the Raspberry Pi Zero and provides local networking. Via the network connection, one can access an IEx prompt via ssh, transfer files via sftp, run firmware updates, use Erlang distribution and anything else that works over IP. IMPORTANT: The Raspberry Pi Zero has two USB ports. The OTG one is the &quot;middle&quot; one. The other one is power-only. When you connect the USB OTG port to your laptop, it should &quot;just&quot; work if you're using OSX or Linux. If you're on Windows and want to access networking natively (not through a Linux VM), you will need to install linux.inf . This file is unsigned and will fail to install unless you disable signed driver enforcement. The basic idea is to go to settings, go to the advanced boot settings and navigate the menus to boot with it off. There are examples on the web.","ref":"readme.html#usb-otg-support","title":"Raspberry Pi Model Zero - USB OTG support","type":"extras"},{"doc":"If you're debugging networking or the boot process, you'll want to use the Raspberry Pi's UART pins on the GPIO connector (the HDMI output can be made to work, but won't be a good development experience). You will need to use a USB-to-UART adapter and connect it to the UART pins on the Raspberry Pi's GPIO header. Make sure to use a USB-to-UART adapter with 3.3V logic levels. This is most of them and to make things confusing, most adapters can supply 5V. Just don't connect the 5V wire.","ref":"readme.html#console-and-kernel-message-configuration","title":"Raspberry Pi Model Zero - Console and kernel message configuration","type":"extras"},{"doc":"The base image includes drivers for the onboard Raspberry Pi Zero W wifi module ( brcmfmac driver). Due to the USB port being placed in gadget mode, this system does not support USB WiFi adapters.","ref":"readme.html#supported-wifi-devices","title":"Raspberry Pi Model Zero - Supported WiFi devices","type":"extras"},{"doc":"The Raspberry Pi has many options for audio output. This system supports the HDMI and stereo audio jack output. The Linux ALSA drivers are used for audio output. To try it out, run: cmd ( &quot;espeak -ven+f5 -k5 -w /tmp/out.wav Hello&quot; ) cmd ( &quot;aplay -q /tmp/out.wav&quot; ) The general Raspberry Pi audio documentation mostly applies to Nerves. For example, to force audio out the HDMI port, run: cmd ( &quot;amixer cset numid=3 2&quot; ) Change the last argument to amixer to 1 to output to the stereo output jack.","ref":"readme.html#audio","title":"Raspberry Pi Model Zero - Audio","type":"extras"},{"doc":"This system supports storing provisioning information in a small key-value store outside of any filesystem. Provisioning is an optional step and reasonable defaults are provided if this is missing. Provisioning information can be queried using the Nerves.Runtime KV store's Nerves.Runtime.KV.get/1 function. Keys used by this system are: Key Example Value Description nerves_serial_number &quot;12345678&quot; By default, this string is used to create unique hostnames and Erlang node names. If unset, it defaults to part of the Raspberry Pi's device ID. The normal procedure would be to set these keys once in manufacturing or before deployment and then leave them alone. For example, to provision a serial number on a running device, run the following and reboot: iex&gt; cmd ( &quot;fw_setenv nerves_serial_number 12345678&quot; ) This system supports setting the serial number offline. To do this, set the NERVES_SERIAL_NUMBER environment variable when burning the firmware. If you're programming MicroSD cards using fwup , the commandline is: sudo NERVES_SERIAL_NUMBER=12345678 fwup path_to_firmware.fw Serial numbers are stored on the MicroSD card so if the MicroSD card is replaced, the serial number will need to be reprogrammed. The numbers are stored in a U-boot environment block. This is a special region that is separate from the application partition so reformatting the application partition will not lose the serial number or any other data stored in this block. Additional key value pairs can be provisioned by overriding the default provisioning.conf file location by setting the environment variable NERVES_PROVISIONING=/path/to/provisioning.conf . The default provisioning.conf will set the nerves_serial_number , if you override the location to this file, you will be responsible for setting this yourself.","ref":"readme.html#provisioning-devices","title":"Raspberry Pi Model Zero - Provisioning devices","type":"extras"},{"doc":"There's a subtle coupling between the nerves_system_br version and the Linux kernel version used here. nerves_system_br provides the versions of rpi-userland and rpi-firmware that get installed. I prefer to match them to the Linux kernel to avoid any issues. Unfortunately, none of these are tagged by the Raspberry Pi Foundation so I either attempt to match what's in Raspbian or take versions of the repositories that have similar commit times.","ref":"readme.html#linux-kernel-and-rpi-firmware-userland","title":"Raspberry Pi Model Zero - Linux kernel and RPi firmware/userland","type":"extras"},{"doc":"The Linux kernel compiled for Nerves is a stripped down version of the default Raspberry Pi Linux kernel. This is done to remove unnecessary features, select some Nerves-specific features, and to save space. To reproduce the kernel configuration found here, do the following (this is somewhat tedious): Start with arch/arm/configs/bcmrpi_defconfig . This is the kernel configuration used in the official Raspberry Pi images. Turn off all filesystems except for ext4 , squashfs , tmpfs , proc , sysfs , and vfat . Squashfs only needs ZLIB support. vfat needs to default to utf8 . Enable native language support for ascii , utf-8 , ISO 8859-1 , codepage 437, and codepage 850. Disable all network drivers and wireless LAN drivers except for Broadcom FullMAC WLAN. Disable PPP and SLIP Disable the WiFi drivers in the Staging drivers menus Disable TV, AM/FM, Media USB adapters, DVB Frontends and Remote controller support in the Multimedia support menus. Go to Device Drivers-&gt;Sound card support . Disable USB sound devices in ALSA. Disable Open Sound System . Go to Device Drivers-&gt;Graphics support . Disable DisplayLink Disable everything in HID support (NOTE: revisit for Bluetooth) Disable everything in input device support (can't plug it in anyway) In the Device Drivers &gt; USB support menu, enable gadget mode and disable all host mode. It should be possible to completely disable USB host mode if all of the USB drivers in previous steps were disabled. See DesignWare USB2 Core Support-&gt;DWC Mode Selection and select CDC Composite Device (Ethernet and ACM) . If you want dual mode USB host/gadget support, you'll need to reenable a few things. There have been unresolved issues in the past with dual mode support. It's possible that they are fixed, but be sure to test. They were noticed on non-Mac platforms. In Kernel Features , select Preemptible Kernel (Low-Latency Desktop) , disable the memory allocator for compressed pages. In Userspace binary formats , disable support for MISC binaries. In Networking support , disable Amateur Radio support, CAN bus subsystem, IrDA subsystem, Bluetooth, WiMAX, Plan 9, and NFC. (TBD - this may be too harsh, please open issues if you're using any of these and it's the only reason for you to create a custom system.) In Networking options , disable IPsec, SCTP, Asynchronous Transfer Mode, 802.1d Ethernet Bridging, L2TP, VLAN, Appletalk, 6LoWPAN, 802.15.4, DNS Resolver, B.A.T.M.A.N, Open vSwitch, MPLS, and the Packet Generator in Network testing. In Networking support-&gt;Wireless , enable &quot;use statically compiled regulatory rules database&quot;. Build in cfg80211 and mac80211 . Turn off mac80211 mesh networking and LED triggers. Turn off cfg80211 wireless extensions compatibility. In Kernel hacking , disable KGDB, and Magic SysRq key. In Device Drivers, disable MTD support. In Block devices, disable everything but Loopback and RAM block device. Disable SCSI device support. Disable RAID and LVM. In Enable the block layer , deselect everything but the PC BIOS partition type (i.e., no Mac partition support, etc.). In Enable loadable module support , select &quot;Trim unused exported kernel symbols&quot;. NOTE: If you're having trouble with an out-of-tree kernel module build, try deselecting this!! In General Setup , turn off initramfs/initfd support, Kernel .config support, OProfile. In Device Drivers -&gt; I2C -&gt; Hardware Bus Support compile the module into the kernel and disable everything but BCM2708 BSC support. In Device Drivers -&gt; SPI compile in the BCM2835 SPI controller and User mode SPI device driver support. In Device Drivers -&gt; Dallas's 1-wire support , disable everything but the GPIO 1-Wire master and the thermometer slave. (NOTE: Why is the thermometer compiled in? This seems historical.) Disable Hardware Monitoring support , Sonics Silicon Backplane support In Device Drivers -&gt; Character devices -&gt; Serial drivers , disable 8250 and SC16IS7xx support. Disable the RAW driver. In Networking support-&gt;Network options , disable IP: kernel level autoconfiguration In Networking support-&gt;Network options-&gt;TCP: advanced congestion control disable everything except for CUBIC TCP . Disable Real Time Clock . Disable everything in Cryptographic API and Library routines that can be disabled. Sometimes you need to make multiple passes. Disable EEPROM 93CX6 support, PPS support, all GPIO expanders, Speakup core, Media staging drivers, STMicroelectronics STMPE, anything &quot;Wolfson&quot;. Disable most ALSA for SoC audio support and codecs. NOTE: We probably should support a few, but I have no clue which ones are most relevant and there are tons of device drivers in the list. Disable IIO and UIO. Disable NXP PCA9685 PWM driver Image credit : This image is from the Fritzing parts library.","ref":"readme.html#linux-kernel-configuration-notes","title":"Raspberry Pi Model Zero - Linux kernel configuration notes","type":"extras"},{"doc":"Changelog","ref":"changelog.html","title":"Changelog","type":"extras"},{"doc":"This is a security/bug fix release that updates to Buildroot 2021.02.1 and OTP 23.3.1. It should be safe for everyone to apply. Improvements espeak has been removed from the default install to trim 13 MB off the root filesystem Updated dependencies nerves_system_br v1.15.1 Buildroot 2021.02 Erlang/OTP 23.3.1","ref":"changelog.html#v1-15-1","title":"Changelog - v1.15.1","type":"extras"},{"doc":"This release updates to Buildroot 2021.02 and OTP 23.2.7. If you have made a custom system off this one, please review the nerves_system_br v1.15.0 release notes. The Nerves toolchain has also been updated to v1.4.2. This brings in Linux 4.14 headers to enable use of cdev and eBPF. This won't affect most users. Updated dependencies nerves_system_br v1.15.0 Buildroot 2021.02 Erlang/OTP 23.2.7 nerves toolchains v1.4.2","ref":"changelog.html#v1-15-0","title":"Changelog - v1.15.0","type":"extras"},{"doc":"This is a patch release for v1.14.0 which fixes the ABI spec passed for zigler. Improvements A few unused directories in /etc have been removed. These primarily were network initialization script directories that aren't used on Nerves, but were provided by default by Buildroot.","ref":"changelog.html#v1-14-1","title":"Changelog - v1.14.1","type":"extras"},{"doc":"This release updates to Buildroot 2020.11.2, GCC 10.2 and OTP 23.2.4. When migrating custom systems based on this one, please be aware of the following important changes: There's a new getrandom syscall that is made early in BEAM startup. This blocks the BEAM before rngd can be started to provide entropy. The workaround is to start rngd from erlinit . See erlinit.config . Hardware float is enabled ( eabihf ). If you have pre-built binaries, you will need to compile them since previous eabi was used. The GCC 10.2.0 toolchain has a different name that calls out &quot;nerves&quot; as the vendor and the naming is now more consistent with other toolchain providers. Experimental support for tooling that requires more information about the target has been added. The initial support focuses on zigler. Updated dependencies nerves_system_br: bump to v1.14.4 Buildroot 2020.11.2 Erlang/OTP 23.2.4 Nerves toolchains 1.4.1","ref":"changelog.html#v1-14-0","title":"Changelog - v1.14.0","type":"extras"},{"doc":"This is a bug fix release and contains no major changes. Updated dependencies nerves_system_br: bump to v1.13.7 Erlang/OTP 23.1.5","ref":"changelog.html#v1-13-3","title":"Changelog - v1.13.3","type":"extras"},{"doc":"This release includes a patch release update to Buildroot 2020.08.2 . Updated dependencies nerves_system_br: bump to v1.13.5 erlinit 1.9.0 Improvements Switched source for built-in WiFi module firmware. This pulls in newer firmware versions that were found to fix issues on the Raspberry Pi 4. It may improve built-in WiFi on other Raspberry Pis.","ref":"changelog.html#v1-13-2","title":"Changelog - v1.13.2","type":"extras"},{"doc":"The main change in this release is to bump the Linux kernel to 5.4. This follows the kernel update in the Raspberry Pi OS. If you have based a custom system off of this one, please inspect the nerves_defconfig for WiFi firmware changes. WiFi firmware is no longer being pulled from the rpi-wifi-firmware since that package is out of date. Updated dependencies nerves_system_br: bump to v1.13.4 Erlang/OTP 23.1.4 boardid 1.10.0 Improvements Enabled reproducible builds in Buildroot to remove some timestamp and build path differences in firmware images. This helps delta firmware updates. The memory cgroup controller is no longer enabled by default. This was an upstream change. As a result, the memory cgroup directory is no longer mounted.","ref":"changelog.html#v1-13-1","title":"Changelog - v1.13.1","type":"extras"},{"doc":"This release updates to Buildroot 2020.08 and OTP 23.1.1. Updated dependencies nerves_system_br: bump to v1.13.2 Erlang/OTP 23.1.1 erlinit 1.8.0 nerves 1.7.0 New features Added support for updating the root filesystem using firmware patches. See the firmware patch docs for more information.","ref":"changelog.html#v1-13-0","title":"Changelog - v1.13.0","type":"extras"},{"doc":"This release updates to Buildroot 2020.05.1 and OTP 23.0.3 which are both bug fix releases. Updated dependencies nerves_system_br: bump to v1.12.4 Erlang/OTP 23.0.3 nerves_heart v0.3.0 New features The /data directory now exists for storing application-specific data. It is currently a symlink to /root . Using /data will eventually be encouraged over /root even though currently there is no advantage. This change makes it possible to start migrating paths in applications and libraries. Fixes Fixed old references to the -Os compiler flag. All C/C++ code will default to using -O2 now.","ref":"changelog.html#v1-12-2","title":"Changelog - v1.12.2","type":"extras"},{"doc":"Fixes Remove nerves_system_linter from hex package. This fixes mix dependency errors in projects that reference systems with different nerves_system_linter dependency specs.","ref":"changelog.html#v1-12-1","title":"Changelog - v1.12.1","type":"extras"},{"doc":"This release updates the system to use Buildroot 2020.05 and Erlang/OTP 23. Please see the respective release notes for updates and deprecations in both projects for changes that may affect your application. Updated dependencies nerves_system_br v1.12.0 Erlang/OTP 23.0.2 Linux 4.19.118 (Raspberry Pi 1.2020601 tag) Raspberry Pi firmware 1.2020601","ref":"changelog.html#v1-12-0","title":"Changelog - v1.12.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.4 Erlang 22.3.4.1 fwup 1.7.0","ref":"changelog.html#v1-11-2","title":"Changelog - v1.11.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.11.2 Erlang 22.3.1 erlinit 1.7.0 - tty initialization support fwup 1.6.0 - xdelta3/VCDIFF patch support Enable unixodbc so that Erlang's odbc application can be used in projects","ref":"changelog.html#v1-11-1","title":"Changelog - v1.11.1","type":"extras"},{"doc":"This release updates Buildroot to 2020.02 and upgrades gcc from 8.3 to 9.2. While this is a minor version bump due to the Buildroot release update, barring advanced usage of Nerves, this is a straightforward update from v1.10.2. Updated dependencies nerves_system_br v1.11.0 linux 4.19.97 (raspberrypi-kernel_1.20200212-1 tag) Erlang 22.2.8","ref":"changelog.html#v1-11-0","title":"Changelog - v1.11.0","type":"extras"},{"doc":"Fixes This fixes a regression on OSX where the USB gadget Ethernet would incorrectly try to go into RNDIS mode and not work. Gadget Ethernet works with this fix on Linux and OSX. It also works on Windows with a driver installed. See the README.md for details. Updated dependencies nerves_system_br v1.10.2 Erlang 22.2.4","ref":"changelog.html#v1-10-2","title":"Changelog - v1.10.2","type":"extras"},{"doc":"This release changes the behavior of the gadget port as well as the UART pins on the GPIO header. The gadget driver has been changed to use g_ether. This provides a more stable network connection at the expense of the virtual serial port. Console access has been output to the UART. If you were using the UART to connect to peripherals, you will need to disable the console. See: https://hexdocs.pm/nerves/advanced-configuration.html#overwriting-files-in-the-boot-partition for more information. Enhancements Set expand=true on the application data partition. This will only take effect for users running the complete task, fwup will not expand application data partitions that exist during upgrade tasks. linux: swap the cdc composite gadget for g_ether Updated dependencies nerves_system_br v1.10.1 Erlang 22.2.3","ref":"changelog.html#v1-10-1","title":"Changelog - v1.10.1","type":"extras"},{"doc":"This release updates Buildroot to 2019.11 with security and bug fix updates across Linux packages. Enables dnsd, udhcpd and ifconfig in the default Busybox configuration to support vintage_net and vintage_net_wizard . See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.10.0 Erlang 22.1.8","ref":"changelog.html#v1-10-0","title":"Changelog - v1.10.0","type":"extras"},{"doc":"This release updates Buildroot to 2019.08.2 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Erlang/OTP is now at 22.1.7. Updated dependencies nerves_system_br v1.9.5","ref":"changelog.html#v1-9-2","title":"Changelog - v1.9.2","type":"extras"},{"doc":"This release pulls in security and bug fix updates from nerves_system_br . Erlang/OTP is now at 22.1.1. Updated dependencies nerves_system_br v1.9.4 linux - update to the raspberrypi-kernel_1.20190925-1 tag","ref":"changelog.html#v1-9-1","title":"Changelog - v1.9.1","type":"extras"},{"doc":"This release updates Buildroot to 2019.08 with security and bug fix updates across Linux packages. See the nerves_system_br notes for details. Updated dependencies nerves_system_br v1.9.2","ref":"changelog.html#v1-9-0","title":"Changelog - v1.9.0","type":"extras"},{"doc":"This release fixes an issue that broke display output on small LCD screens. Updating the Raspberry Pi firmware to the latest from the Raspberry Pi Foundation fixed the issue. See https://github.com/fhunleth/rpi_fb_capture/issues/2 for details. Updated dependencies nerves_system_br v1.8.5","ref":"changelog.html#v1-8-2","title":"Changelog - v1.8.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.8.4 Linux 4.19.58 with patches from the Raspberry Pi Foundation","ref":"changelog.html#v1-8-1","title":"Changelog - v1.8.1","type":"extras"},{"doc":"This release This release updates Erlang to OTP 22 and gcc from version 7.3.0 to 8.3.0. See the nerves_system_br and toolchain release notes for more information. Enhancements Enable source-based routing in the Linux kernel to support vintage_net Updated dependencies Erlang 22.0.4 nerves_system_br v1.8.2 nerves_toolchain_arm_unknown_linux_gnueabihf v1.2.0","ref":"changelog.html#v1-8-0","title":"Changelog - v1.8.0","type":"extras"},{"doc":"Bux fixes Add TAR option --no-same-owner to fix errors when untarring artifacts as the root user. Updated dependencies nerves_system_br v1.7.2","ref":"changelog.html#v1-7-2","title":"Changelog - v1.7.2","type":"extras"},{"doc":"This release fixes a major issue with the gadget USB port where it would hang on boot. If you have made a custom system or are overriding the erlinit.config file in your project, please make sure that your erlinit.config has: -c null -s &quot;/usr/bin/nbtty --tty /dev/ttyGS0 --wait-input&quot; Bug fixes Fix regression with virtual serial port where it could cause the whole USB interface to hang. Improvements Bump C compiler options to -O2 from -Os . This provides a small, but measurable performance improvement (500ms at boot in a trivial project). Updated dependencies nerves_system_br v1.7.1","ref":"changelog.html#v1-7-1","title":"Changelog - v1.7.1","type":"extras"},{"doc":"This release bumps the Linux kernel to 4.19.25. This change had an impact on how the WiFi regulatory database gets loaded into the kernel. Instead of building it into the kernel as previously done, the kernel loads it on demand. This requires that all WiFi drivers be built as kernel modules so that the database isn't loaded before the root filesystem is mounted. If you made a custom system and see boot errors about not being able to load the regulatory database, this is the problem. A known bug with the Raspberry Pi Zero USB gadget interface is that it sometimes doesn't load on Linux systems. Moving the gadget drivers to kernel modules seems to work around this but it takes longer to load the gadget interface. Updated dependencies nerves_system_br v1.7.0 Linux 4.19.25 with patches from the Raspberry Pi Foundation","ref":"changelog.html#v1-7-0","title":"Changelog - v1.7.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.8 Erlang 21.2.6","ref":"changelog.html#v1-6-3","title":"Changelog - v1.6.3","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.6 Erlang 21.2.4 boardid 1.5.3","ref":"changelog.html#v1-6-2","title":"Changelog - v1.6.2","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.6.5 Erlang 21.2.2 boardid 1.5.2 erlinit 1.4.9 OpenSSL 1.1.1a Linux 4.14.89 with patches from the Raspberry Pi Foundation Enhancements Moved boardid config from inside erlinit.config to /etc/boardid.config Compile gpiomem into the Linux kernel Enable pstore, an in-memory buffer that can capture logs, kernel oops and other information when unexpected reboots. The buffer can be recovered on the next boot where it can be inspected.","ref":"changelog.html#v1-6-1","title":"Changelog - v1.6.1","type":"extras"},{"doc":"This pulls in a pending patch in Buildroot to update the version of OpenSSL from 1.0.2 to 1.1.0h. This fixes what appears to be issues with Erlang using OpenSSL engines. It also enables Erlang crypto algorithms such as ed25519 that have been added in recent Erlang releases. Updated dependencies nerves_system_br v1.6.1 Erlang 21.2 Added dependencies wpa_passphrase libp11 0.4.9","ref":"changelog.html#v1-6-0","title":"Changelog - v1.6.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.5.3","ref":"changelog.html#v1-5-1","title":"Changelog - v1.5.1","type":"extras"},{"doc":"This release updates the Linux kernel from 4.4 to 4.14.71. Enhancements Added Alsa utils aplay and amixer for audio support. Added espeak a speech synthesizer for text to audio. Automatically reboot if the Linux kernel panics (defaults to a 10 second delay before the reboot) Updated dependencies nerves_system_br v1.5.2 Linux 4.14.71 with patches from the Raspberry Pi Foundation Erlang 21.0.9","ref":"changelog.html#v1-5-0","title":"Changelog - v1.5.0","type":"extras"},{"doc":"This release contains various updates to provisioning variables and data. Host requirements Building firmware using this system requires fwup to be updated on your host computer to at least v1.2.5 . The target minimum version requirement has not changed from 0.15.0 . Serial numbers Device serial numbers are now set using NERVES_SERIAL_NUMBER instead of SERIAL_NUMBER . This is to reduce ambiguity on the source of the serial by name spacing it along side other Nerves variables. The U-Boot environment key has also changed from serial_number to nerves_serial_number . The erlinit.config has been updated to provide backwards compatibility for setting the hostname from the serial number by checking for nerves_serial_number and falling back to serial_number . Custom provisioning Provisioning data is applied at the time of calling the fwup task complete . The complete task is executed when writing the firmware to the target disk. During this time, fwup will include the contents of a provisioning file located at ${NERVES_SYSTEM}/images/fwup_include/provisioning.conf . By default, this file only sets nerves_serial_number . You can add additional provisioning data by overriding the location of this file to include your own by setting the environment variable NERVES_PROVISIONING . If you override this variable you will be responsible for also setting nerves_serial_number . Updated dependencies nerves_system_br v1.4.5","ref":"changelog.html#v1-4-0","title":"Changelog - v1.4.0","type":"extras"},{"doc":"This release upgrades gcc from version 6.3.0 to 7.3.0. See the toolchain release notes for more information. Updated dependencies nerves_system_br v1.4.1 nerves_toolchain_armv6_rpi_linux_gnueabi v1.1.0","ref":"changelog.html#v1-3-0","title":"Changelog - v1.3.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.3.2","ref":"changelog.html#v1-2-1","title":"Changelog - v1.2.1","type":"extras"},{"doc":"This release updates Erlang to OTP 21.0 Updated dependencies nerves_system_br v1.3.0","ref":"changelog.html#v1-2-0","title":"Changelog - v1.2.0","type":"extras"},{"doc":"This release fixes some issues and adds firmware UUID support. This support can be used to unambiguously know what's running on a device. Updated dependencies nerves_system_br v1.2.2 Bug fixes Empty serial numbers stored in the U-Boot environment would be used instead of reverting to devices IDs built into the CPU or board. It wasn't possible to enable QtWebEngine (needed for kiosk apps)","ref":"changelog.html#v1-1-1","title":"Changelog - v1.1.1","type":"extras"},{"doc":"This release adds official support for provisioning serial numbers to devices. Other information can be provisioned in a similar manner. See the README.md for details. Buildroot was also updated to 2018.05. Be sure to review the nerves_system_br link for the changes in the embedded Linux components. Updated dependencies nerves_system_br v1.2.0 New features More wpa-supplicant features were enabled to support more WiFi use-cases","ref":"changelog.html#v1-1-0","title":"Changelog - v1.1.0","type":"extras"},{"doc":"This release is nearly identical to rc.1 except for pulling the official 1.0 versions of Nerves dependencies and minor documentation updates. Updated dependencies nerves_system_br v1.0.0 nerves_toolchain v1.0.0 nerves v1.0.0","ref":"changelog.html#v1-0-0","title":"Changelog - v1.0.0","type":"extras"},{"doc":"This release contains updates to Erlang and heart from nerves_system_br and mostly cosmetic changes to this project. The trivial .fw files are no longer created by CI scripts. If you've forked this project and are building systems using CI, make sure to update your publish scripts. Updated dependencies nerves_system_br v1.0.0-rc.2","ref":"changelog.html#v1-0-0-rc-1","title":"Changelog - v1.0.0-rc.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v1.0.0-rc.0 nerves_toolchain v1.0.0-rc.0 nerves v1.0.0-rc.0","ref":"changelog.html#v1-0-0-rc-0","title":"Changelog - v1.0.0-rc.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.17.0 nerves_toolchain v0.13.0 nerves v0.9.0","ref":"changelog.html#v0-21-0","title":"Changelog - v0.21.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.16.3 This fixes the call to otp_build so that it always uses Buildroot's version the autoconf tools.","ref":"changelog.html#v0-20-1","title":"Changelog - v0.20.1","type":"extras"},{"doc":"Important: This image removes kernel log messages from the HDMI and UART ports. They are now only available via dmesg . If you're debugging a boot hang, you can re-enable prints by updating the cmdline.txt. See README.md. Updated dependencies nerves_system_br v0.16.1-2017-11 Bug fixes Removed kernel logging from UART and HDMI to avoid interfering with other uses. They are rarely used on those ports. Enhancements Reboot automatically if Erlang VM exits - This is consistent with other Nerves systems. See rootfs_overlay/etc/erlinit.config if undesired. Start running nerves_system_linter to check for configuration errors. Disable console blanking for HDMI to make it easier to capture error messages. Automount the boot partition readonly at /boot Support for reverting firmware. See Reverting Firmware for more info on reverting firmware. See fwup-revert.conf for more information on how fwup handles reverting.","ref":"changelog.html#v0-20-0","title":"Changelog - v0.20.0","type":"extras"},{"doc":"Bug fixes Updated toolchains to 0.12.1 which fixes issues with missing app files.","ref":"changelog.html#v0-19-2","title":"Changelog - v0.19.2","type":"extras"},{"doc":"Bug fixes Rollback release due to errors with toolchains not defining erlang app files","ref":"changelog.html#v0-19-1","title":"Changelog - v0.19.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.15.1 nerves v0.8.3 nerves_toolchain_armv6_rpi_linux_gnueabi v0.12.0 Enhancements Support for nerves 0.8.x Moved nerves.exs to mix.exs","ref":"changelog.html#v0-19-0","title":"Changelog - v0.19.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.14.1","ref":"changelog.html#v0-18-2","title":"Changelog - v0.18.2","type":"extras"},{"doc":"Bug fixes Build nbtty","ref":"changelog.html#v0-18-1","title":"Changelog - v0.18.1","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.14.0 Buildroot 2017.08 fwup 0.17.0 erlinit 1.2.0 nbtty 0.3.0 Enhancements Add global patch directory This is required to pull in the e2fsprogs patch that's needed now that util-linux's uuid_generate function calls getrandom and can block indefinitely for the urandom pool to initialize Bug fixes Use nbtty by default to fix tty hang issue","ref":"changelog.html#v0-18-0","title":"Changelog - v0.18.0","type":"extras"},{"doc":"Updated dependencies nerves_system_br v0.13.7","ref":"changelog.html#v0-17-1","title":"Changelog - v0.17.1","type":"extras"},{"doc":"This release contains an updated toolchain with Linux 4.1 Headers. You will have to clean and compile any c/c++ code in your project and dependencies. Failure to do so will result in an error when producing firmware. nerves_system_br v0.13.5 fwup 0.15.4 Nerves toolchain v0.11.0 New Features Fix warnings for Elixir 1.5 Remove unused options from OTP 20 update Per Buildroot convention, the rootfs-additions directory is being renamed to rootfs_overlay. A symlink is put in its place to avoid breaking any systems. Enabled IPv6 Support in Linux kernel","ref":"changelog.html#v0-17-0","title":"Changelog - v0.17.0","type":"extras"},{"doc":"nerves_system_br v0.13.2 OTP 20 erlinit 1.1.3 fwup 0.15.3 New features Firmware updates verify that they're updating the right target. If the target doesn't say that it's an rpi0 through the firmware metadata, the update will fail. Added meta-misc and meta-vcs-identifier to the fwup.conf metadata for use by users and for the regression test framework Bug fixes The erlinit update fixes a hang issue that occurs on reboots if nothing is connected to the USB virtual serial console.","ref":"changelog.html#v0-16-0","title":"Changelog - v0.16.0","type":"extras"},{"doc":"nerves_system_br v0.12.1 erlinit 1.1.1 fwup 0.15.0 New features The application data partition is now ext4 . This greatly improves its robustness to corruption. Nerves.Runtime contains code to initialize it on first boot. Firmware images now contain metadata that can be queried at runtime (see Nerves.Runtime.KV Increased GPU memory to support Pi Camera V2","ref":"changelog.html#v0-15-0","title":"Changelog - v0.15.0","type":"extras"},{"doc":"nerves_system_br v0.12.0 Buildroot 2017.05 erlinit 1.1.0 New features pigpio is now available by default (enables near real-time use of gpios) Bug fixes USB host/gadget mode selection doesn't seem to work on some non-Apple hardware. Host support has been disabled as a workaround. See Issue 10 for details. Other changes pi3-miniuart-bt overlay is enabled by default to give full speed UART access on GPIO pins","ref":"changelog.html#v0-14-0","title":"Changelog - v0.14.0","type":"extras"},{"doc":"nerves_system_br v0.11.1 erlinit 1.0.1 - contains fix for Erlang VM exit detection issue","ref":"changelog.html#v0-13-1","title":"Changelog - v0.13.1","type":"extras"},{"doc":"The brcmfmac wireless driver is now built as a module, so you will need to load it. See hello_wifi for an example of WiFi module loading on application startup. nerves_system_br v0.11.0 erlinit 1.0 fwup 0.14.2 rpi-userland and rpi-firmware version bumps to correspond with Raspbian Linux 4.4 updates","ref":"changelog.html#v0-13-0","title":"Changelog - v0.13.0","type":"extras"},{"doc":"This is the first official Raspberry Pi Zero system release. It was forked off nerves_system_rpi so previous versions are from that project. Those also work on the Zero, but without USB gadget mode or RPi Zero W WiFi support. nerves_system_br v0.10.0 Buildroot 2017.02 Erlang/OTP 19.3 New features Upgraded the Linux kernel from 4.4.43 -&gt; 4.4.50. Due to the coupling between the Linux kernel and rpi-firmware and possibly rpi-userland, if you have a custom system based off this, you should update your Linux kernel as well. (see nerves_defconfig changes)","ref":"changelog.html#v0-12-0","title":"Changelog - v0.12.0","type":"extras"},{"doc":"New features Enabled USB_SERIAL and FTDI_SIO support. Needed for connecting with Arduino to the USB ports Support for Nerves 0.5.0","ref":"changelog.html#v0-11-0","title":"Changelog - v0.11.0","type":"extras"},{"doc":"New features Upgraded the Linux kernel to 4.4.43. This also removes the call to mkknlimg which is no longer needed. Bump toolchain to use gcc 5.3 (previously using gcc 4.9.3)","ref":"changelog.html#v0-10-0","title":"Changelog - v0.10.0","type":"extras"},{"doc":"Bug Fixes Loosen mistaken nerves dep on 0.4.0 to ~&gt; 0.4.0","ref":"changelog.html#v0-9-1","title":"Changelog - v0.9.1","type":"extras"},{"doc":"This version switches to using the nerves_package compiler. This will consolidate overall deps and compilers. Nerves.System.BR v0.8.1 Support for distillery Support for nerves_package compiler","ref":"changelog.html#v0-9-0","title":"Changelog - v0.9.0","type":"extras"},{"doc":"When upgrading to this version, be sure to review the updates to nerves_defconfig if you have customized this system. nerves_system_br v0.7.0 Package updates Buildroot 2016.08 Linux 4.4","ref":"changelog.html#v0-7-0","title":"Changelog - v0.7.0","type":"extras"},{"doc":"Package versions Nerves.System.BR v0.6.1 New features All Raspberry Pi-specific configuration is now in this repository Enabled SMP Erlang - even though the RPi Zero and Model B+ are single core systems, some NIFs require SMP Erlang.","ref":"changelog.html#v0-6-1","title":"Changelog - v0.6.1","type":"extras"},{"doc":"Nerves.System.BR v0.6.0 Package updates Erlang OTP 19 Elixir 1.3.1 fwup 0.8.0 erlinit 0.7.3 bborg-overlays (pull in I2C typo fix from upstream) Bug fixes Synchronize file system kernel configs across all platforms","ref":"changelog.html#v0-6-0","title":"Changelog - v0.6.0","type":"extras"},{"doc":"Enhancements Enabled USB Printer kernel mod. Needs to be loaded with modprobe to use Bug Fixes(raspberry pi) Enabled multicast in linux config for rpi/rpi2/rpi3/ev3","ref":"changelog.html#v0-5-2","title":"Changelog - v0.5.2","type":"extras"},{"doc":"Nerves.System.BR v0.5.1 Bug Fixes(nerves-env) Added include paths to CFLAGS and CXXFLAGS Pass sysroot to LDFLAGS","ref":"changelog.html#v0-5-1","title":"Changelog - v0.5.1","type":"extras"},{"doc":"Nerves.System.BR v0.5.0 New features WiFi drivers enabled by default on RPi2 and RPi3 Include wireless regulatory database in Linux kernel by default on WiFi-enabled platforms. Since kernel/rootfs are read-only and coupled together for firmware updates, the normal CRDA/udev approach isn't necessary. Upgraded the default BeagleBone Black kernel from 3.8 to 4.4.9. The standard BBB device tree overlays are included by default even though the upstream kernel patches no longer include them. Change all fwup configurations from two step upgrades to one step upgrades. If you used the base fwup.conf files to upgrade, you no longer need to finalize the upgrade. If not, there's no change.","ref":"changelog.html#v0-5-0","title":"Changelog - v0.5.0","type":"extras"}]